%%%%%%%%%%%%%%%%%%%%
%3.get_MCS
%	-input: .koCov files
%	-output: MCS.mat
%%%%%%%%%%%%%%%%%%%%%

clear all

%% SET FILTERS
filter_unmappable_genomes=1; %C

%% SET DIRS
%koCovDIR='C:\sharon\lab\StrainVariation\DATA\koCov\';
koCovDIR='M:/PROJECTS/StrainVariation_SG/BWA/koCov/';

if filter_unmappable_genomes
    koCovDIR = [koCovDIR 'gFilter\'];
else
    koCovDIR = [koCovDIR 'gNoFilter\'];
end

%% get LIST OF koCOV FILES
D = dir([koCovDIR '*.koCov']);
for ii = 1:length(D)
    samples{ii} = strtok(D(ii).name,'merged');
    samples{ii}=samples{ii}(1:end-1);
end
MCS.samples=samples';

%% get SAMPLE CLASS
load sampleClass
[c ia]=ismember(samples,sampleClass(:,1));
MCS.sampleClass=sampleClass(ia,2:3);

%% get MARKER KOs [40x1]
load markerKOs_13
MCS.kos=markers;

%% get CLUSTER INFO
load CLUSTER
MCS.clusters=CLUSTER.id;

%% GET MARKERS IN CLUSTERS
LANDSCAPE_refGenomes_merged_proteins_annotated_kolist_tbl;
load clusterMap;

[c ia ib] =intersect(markers,items);
ix(ia)=ib;
pptable=pptable(:,ix);
for ii=1:length(MCS.clusters)
    taxIDs=clusterMap(strmatch(MCS.clusters{ii},clusterMap(:,2),'exact'),1);
    cluster2kos(ii,:)=sum(pptable(ismember(spcs,taxIDs),:),1);
end
MCS.vals=zeros(length(MCS.clusters),length(MCS.kos),length(MCS.samples));
MCS.vals(repmat(cluster2kos,[1 1 length(MCS.samples)])<1)=-1;
%}
%% READ IN A SAMPLE [{clusters} {kos} {cov}]

for ii = 1:length(D)
   fid = fopen([koCovDIR D(ii).name]);
    F=textscan(fid,'%s',1);
    F=textscan(fid,'%s%s%f','delimiter',',');
    fclose(fid);
    [km kmIX] = ismember(F{2},MCS.kos);
    [c cIX] = ismember(F{1},MCS.clusters);

    %% get MARKER GENE COV for each CLUSTER [101x40]
    for cc = 1:length(MCS.clusters)
        index=kmIX(cIX==cc & km);
        vals=F{3}(cIX==cc & km);
        MCS.vals(cc,index,ii)=vals;
    end
end

for cc=1:length(MCS.clusters)
    mask=cluster2kos(cc,:)>0;
    for ss=1:length(MCS.samples)
        MCS.mcs(cc,ss)=mean(MCS.vals(cc,mask,ss));
    end
end