#!/usr/bin/perl -w

############################################################
### VARIABLES
############################################################
$maxEdit = shift(@ARGV);
$allCt=0;
%qIDs=();
############################################################
### READ IN SAM ENTRIES
############################################################

while (<>) {
	# print headers
	if (/^@/)
	{	print;	next;}
	
	my @t = split("\t");
	$allCt++;

	################
	#dont print unmapped reads
	################
	if ($t[1]==4)
	{	next;	}
	
	
	################
	#mark duplicate reads
	################
	$qID = $t[0];
	if (exists $qIDs{$qID})
	{	print "dup"; print; next;	}
	else 
	{	$qIDs{$qID}=1;	}
	($numHits) = (/X0:i:(\d+)/);
	($altHits) =  (/\tXA:Z:(\S+)/);
	
	################
	##dont print >maxHits reads
	################
	if (not defined $altHits) 
	{	
		if ($numHits>1)
		{	next;	}
		elsif ($numHits == 1)
		{	$altHits = "";	}
	}
	
	################################
	# get the edit dist of all 'tied' hits  
	# only print 'tied' hits with best edit dist 
	# dont print >maxEdit reads
	################################
	@editDists=();
	@splitHits = ();
	
	# look at primary hit
	($editDist)  = (/XM:i:(\d+)/);
	$bestEdit=$editDist;
	push(@splitHits,join("\t", @t[0..3], $numHits, @t[5..12]) . "\n");	
	push (@editDists,$editDist);
	
	# now look at the rest of the tied hits
	while ($altHits =~ /([^,;]+),([-+]\d+),([^,]+),(\d+);/g) 
	{
		# get editDist and compare to best
		$editDist=$4;
		if ($editDist <= $bestEdit)
		{
			$bestEdit = $editDist;
			#$mchr = ($t[6] eq $1)? '=' : $t[6]; # FIXME: TLEN/ISIZE is not calculated!
			#$seq = $t[9];
			#$phred = $t[10];
			# if alternative alignment has other orientation than primary,
			# then print the reverse (complement) of sequence and phred string
			#if ((($t[1]&0x10)>0) xor ($2<0)) 
		#{
			#	$seq = reverse $seq;
			#	$seq =~ tr/ACGTacgt/TGCAtgca/;
			#	$phred = reverse $phred;
			#}
			push(@splitHits,join("\t", $t[0], 0x100|($t[1]&0x6e9)|($2<0?0x10:0), $1, abs($2), $numHits, $3, @t[6..7], 0, $t[9], $t[10], $t[11],"NM:i:$4") . "\n");
			push (@editDists,$editDist);
		}
	}	
	
	if ($bestEdit<=$maxEdit)
	{	
		foreach $hit (@splitHits)
		{	
			$editDist = shift(@editDists);
			if ($editDist <= $bestEdit)
			{	print $hit;			}
		}
	} 
}

