#!/usr/bin/perl -w
use Net::FTP;

########################################
$LAB='/net/borenstein/vol1';
#$in_taxID_list = $LAB . '/PROJECTS/StrainVariation_SG/DATA/REVISION/new_ref_genomes/REVISION.newGenomes.taxids';
$in_taxID_list ='RefSets/LANDSCAPE_REF_GENOMES/REVISION/REVISION.newGenomes.GENBANK.taxids';
#@FTPs=('ftp.ncbi.nih.gov/genbank/genomes/Bacteria','ftp.ncbi.nih.gov/genomes/Bacteria_DRAFT');
#@DBnames=('genbank','draft');
@FTPs=('ftp.ncbi.nih.gov/genbank/genomes/Bacteria');
@DBnames=('genbank');

$out_dir='RefSets/LANDSCAPE_REF_GENOMES/REVISION';
$fnaDir = 'nucleotide_fastas';
$pttDir = 'gene_calls';
$faaDir= 'protein_fastas';
#########################################3
#  *input*	 list of taxon ids
###  download nucleotide and protein fastas and gene calls
###  look at gbk file - dont download plasmids
###  look at gbk file - if multiple for one taxid, download genbank version, or newest
#  *output* 	for each taxid: .fna file, .ptt file, .faa file - make sure each is zipped as a tgz
###	.taxonInfo	info from gbk etc for each file downloaded
###	.downloadLog	list of the input taxids and how many files were downloaded for each, mark if problems encountered
############################################
## downloads complete genomes from NCBI according to a supplied list of taxonIDs
	###READ IN A LIST OF TAXON IDS, AND AN FTP ADDRESS
	###FOR EACH FOLDER IN FTP, DOWNLOAD EACH .RTP FILE (not .rtp.tgz!), LOOK INSIDE AT TAXON ID, THEN REMOVE .RPT
	### IF TAXON ID IS ON THE LIST, DOWNLOAD .FNA FILE
	### SAVE AS taxID.fileName.fasta
	### gzip it, if not already
	### mark that it was found, so the next db download it again
#####################################################
########################
## set up variables
#####################
$nof_taxIDs = 0;
%h_TaxIDs=();
@missingFiles=();
%h_numFnas=();
%h_numPtts=();
%h_numFaas=();
%h_DB=();
######################################
# --- --- Get a list of all desired taxids --- --- #
print "getting records for: \n";
open (FH_TAX, "$in_taxID_list") or die "Cannot open $in_taxID_list for reading.\n";
while(<FH_TAX>)
{
	$taxid=$_; chomp($taxid);
	$h_TaxIDs{$taxid}=0;
	$h_numFnas{$taxid}=0;
	$h_numPtts{$taxid}=0;
	$h_numFaas{$taxid}=0;
	print "$taxid|";
	$nof_taxIDs++;
}
close(FH_TAX);
print "\n";

##############################
##open info and log files for writing
open (FH_LOG, ">$in_taxID_list" . '.downloadLog') or die "Cannot open $out_dir\/downloadLog.txt for writing.\n";
open (FH_INFO, ">$in_taxID_list" . '.fileInfo') or die "Cannot open $out_dir\/fileInfo.txt for writing.\n";
print FH_INFO "taxid\tDB\taccession\ttaxName\tlineage\tgenomeLength\tgeneCt\tdate\tscfAcc\tseqName\n";

###################
##list folders in the ftp directory
while (@FTPs)
{
	$ftp = shift(@FTPs);
	$DB=shift(@DBnames);
	print "logging into $ftp ...\n";
	($ftp_host, $ftp_dir) = ($ftp =~ m/([^\/]+)(\/.+)/);
	$ftp = Net::FTP->new($ftp_host) or die "cant connect to $@!\n";
	$ftp->login("anonymous", 'greensi@uw.edu') or die "cant login ", $ftp->message;
	$ftp->cwd($ftp_dir) or die "cant change dir! ", $ftp->message;
	@ftp_folders = $ftp->ls();
	$ftp->binary();

#################################
## open each rpt file and get info
#################################
	foreach $spc_folder (@ftp_folders)
	{
		@files = $ftp->ls($spc_folder . "\/*.rpt");
		foreach $rpt_file (@files)
		{
			$taxid="";$acc="";$taxName="";$lineage="";$genomeLength="";$geneCt="";$date="";$scfAcc="";$seqName="";
			$temp_rpt = $ftp->get($rpt_file, "temp.rpt") or die "get failed ", $ftp->message;
			($acc) = ($rpt_file =~ m/([^\\\/]+).rpt$/);
			open (FH_RPT, "$temp_rpt") or die "Cannot open $temp_rpt for reading.\n";
			while(<FH_RPT>)
			{
				$line = $_;	chomp $line;
				if ($line =~ m/Taxname/)
				{	($rest,$taxName) = split(/: /,$line);	}
				if ($line =~ m/Taxid/)
				{	($rest,$taxid) = split(/: /,$line); 	}
				if ($line =~ m/length/)
				{	($rest,$genomeLength) = split(/= /,$line);	}
				if ($line =~ m/Protein count/)
				{	($rest,$geneCt) = split(/: /,$line);	}
			}
			close(FH_RPT);

			####################################
			## check if taxid is on the list
			##################################
			if (exists $h_TaxIDs{$taxid})
			{

				#######################
				## if it is, get gbk file
				#######################
				$gbk_file = $rpt_file; $gbk_file =~ s/rpt/gbk/;
				$temp_gbk = $ftp->get($gbk_file, "temp.gbk") or die "get failed ", $ftp->message;
				open (FH_GBK, "$temp_gbk") or die "Cannot open $temp_gbk for reading.\n";
				while(<FH_GBK>)
				{
					$line = $_;	chomp $line;
					if ($line =~ m/LOCUS/)
					{	@fields = split(/\s+/,$line);
						$gb_acc=$fields[1];
						$date=pop(@fields);
					}
					if ($line =~ m/DEFINITION/)
					{	($seqName) = ($line =~ m/DEFINITION\s+(.+)$/);
						$line = <FH_GBK>; chomp $line;
						while ($line =~ /^\s/)
						{	$line =~ s/^\s+//;
							$line =~ s/\s+$//;
							$seqName .=$line;
							$line = <FH_GBK>; chomp $line;
						}
					}
					if ($line =~ m/ORGANISM/)
					{
						$lineage = "";
						while ($lineage !~ m/\.$/)
						{
							$line = <FH_GBK>;	chomp $line;
							($line) = ($line =~ m/^\s+(\S.+\S)$/);
							$lineage .= $line;
						}
					}
					if ($line =~ m/WGS_SCAFLD/)
					{	($scfAcc) = ($line =~ m/WGS_SCAFLD\s+(.+)$/);	}
					if ($line =~ m/FEATURES/ & ($seqName !~ m/shotgun/))
					{	last;	}
				}
				close(FH_GBK);
				#####################################
				#### if not a plasmid, print to info_file
				#####################################
				if ($seqName !~ m/plasmid/)
				{	#print "---$acc:$taxName:$genomeLength:$geneCt:$date\n";
					#print "---lineage:$lineage\n";
					$numFound++;print "$numFound :";
					$h_TaxIDs{$taxid}++;

					print FH_INFO "$taxid\t$DB\t$gb_acc\t$taxName\t$lineage\t$genomeLength\t$geneCt\t$date\t$scfAcc\t$seqName\n";
					print "$taxid,$DB,$seqName\n";

					#################################
					#### then get the fna files
					###########################
					@fastas = $ftp->ls($spc_folder . "\/$acc*.fna*");
					foreach $fasta_file (@fastas)
					{	$h_numFnas{$taxid}++;
						($filename) = ($fasta_file =~ m/([^\/]+)$/);
						$new_fasta = "$out_dir/nucleotide_fastas/$taxid" . "_" . $filename;
						if (not -e $new_fasta)	{$ftp->get($fasta_file, $new_fasta) or die "get failed ", $ftp->message;}
						print "---fna: $new_fasta\n";

						############################
						### get the ptt
						######################
						($gene_file = $fasta_file) =~ s/fna/ptt/;
						($new_gene = $new_fasta) =~ s/fna/ptt/;
						$new_gene =~ s/$fnaDir/$pttDir/;
						if (not -e $new_gene)	{$ftp->get($gene_file, $new_gene) or push (@missingFiles, $gene_file) ;} # $ftp->message;
						if (-e $new_gene)
						{	print "---ptt: $new_gene\n";
							$h_numPtts{$taxid}++;
						}
						##################
						### get the faa
						###################
						($prot_file = $fasta_file) =~ s/fna/faa/;
						($new_prot = $new_fasta) =~ s/fna/faa/;
						$new_prot =~ s/$fnaDir/$faaDir/;
						if (not -e $new_prot)	{$ftp->get($prot_file, $new_prot) or push (@missingFiles, $prot_file) ;} # $ftp->message;
						if (-e $new_prot)
						{	print "---faa: $new_prot\n";
							$h_numFaas{$taxid}++;
						}
						#######################################
						### if not zipped, zip each, then remove original
						if ( $new_fasta !~ m/.tgz$/)
						{	$old_fasta=$taxid . "_" . $acc . ".fna";
							`tar czf $new_fasta.tgz -C $out_dir/$fnaDir $old_fasta`;
							system('rm',$new_fasta);
						}
						if ( $new_gene !~ m/.tgz$/)
						{	$old_gene=$taxid . "_" . $acc . ".ptt";
							`tar czf $new_gene.tgz -C $out_dir/$pttDir $old_gene`;
							system('rm',$new_gene);
						}
						if ( $new_prot !~ m/.tgz$/)
						{	$old_prot=$taxid . "_" . $acc . ".faa";
							`tar czf $new_prot.tgz -C $out_dir/$faaDir $old_prot`;
							system('rm',$new_prot);
						}


					}
				}
			}
		}
	}
	$ftp->quit;
}

#################
###### print file counts to log
###################
foreach $taxid (sort keys %h_TaxIDs)
{	if (	 $h_TaxIDs{$taxid}>0)
	{	print FH_LOG "$taxid\t$h_numFnas{$taxid}\t$h_numPtts{$taxid}\t$h_numFaas{$taxid}\n";	}
	else
	{	print "$taxid\tno files found for this taxid!\n";	}
}
print FH_LOG "\nmissing files!:\n";
foreach $file (@missingFiles)
{	print "$file\n";	}

close(FH_LOG);
die;
# --- --- --- --- --- -- -- --- --- --- --- --- #



